

clear
clear matrix
clear mata

**** define common directory *****
cd "\\Mfso01\MyDocs\folol\\My Documents\Tidigare projekt"


**************************************************
*** Combine basic dataset with electoral data ****
**************************************************

* Some datasets are delivered separately from Statistics Sweden and require
* us to combine them one by one.

*** For 2010, combine nominated with electoral information and save ***
use "\\Mfso01\p0276_data$\nom_ko_10.dta" , clear

*** join with data for elected in 2010 to add the indicator for being elected ***
*** in the Swedish file, the following names will be used:
*** kund_lopnr_personnr = personal ID code
*** ko_valkretskod = code for electoral district
*** year = year

joinby kund_lopnr_personnr ko_valkretskod ar using "\\Mfso01\p0276_data$\valda_ko_10.dta", unmatched(both) _merge(_merge)
drop _merge

ren vald elected /* rename key variable */
save temp, replace


*** For 1994, combine nominated with electoral information and clean dataset ***

use "\\MFSO01\P0276_Data$\nom94_ko.dta", clear
gen  ar=1994

*** convert variables to make them in the same format across years ****
*** keep Swedish names until all datasets are merged 

tostring llkk, replace /* municipality code */
tostring ko_valkretskod, replace  /* electoral district code */
tostring partikod, replace /* party code */
tostring listnr, replace /* electoral ballot code */
tostring nrinom, replace /* ballot rank */
gen ripartikod = partikod /* adjust party name variable to match */


 ////////////////////////////////////////////////////////////////
forvalues n=0/6 { 
	replace  ko_valkretskod="0`n'" if ko_valkretskod=="`n'"
	}

save temp_94, replace



*****data for elected  1988 is also provided in a seperate file,
***** here we have to do some more cleaning as the data was digitized from paper ballots
use \\Mfso01\p0276_data$\valda_ko_88.dta, clear
****first correct party names''''
gen parti = "Kristdemokraterna" if partinamn=="KRISTDEMOKRATISKA SAMHLLSPARTIET (KDS)"
replace parti= "Vnsterpartiet" if partinamn=="VNSTERPARTIET KOMMUNISTERNA"
replace parti= "Miljpartiet de grna" if partinamn=="MILJPARTIET DE GRNA"
replace parti= "Centerpartiet" if partinamn=="CENTERN"
replace parti ="Arbetarepartiet-Socialdemokraterna" if partinamn=="ARBETAREPARTIET-SOCIALDEMOKRATERNA"
replace parti= "Moderata Samlingspartiet" if partinamn=="MODERATA SAMLINGSPARTIET"
replace parti= "Folkpartiet liberalerna" if partinamn=="FOLKPARTIET"
replace parti= "Annat" if parti==""


**destring variables so that they are in the correct format.
foreach var of varlist llkk ar{
 destring `var', replace force
}
**** there are some municpal ids missing, we ad these
replace llkk=1401 if kommunnamn=="HRRYDA"
replace llkk=1381 if kommunnamn=="LAHOLM"
replace llkk=2085 if kommunnamn=="LUDVIKA"
replace llkk=1484 if kommunnamn=="LYSEKIL"

****creat dummy for being elected
gen elected =1


**** save temporary file for those elected in 1988
save temp88, replace

*** Open data for 1991-2006 ***

use "\\MFSO01\P0276_Data$\nom_ko.dta", clear
tostring llkk, replace force

* If you have doubles of th

drop if ar== 1994

drop vald

append using temp_94

****add the elected politicans to the nominated
**** match by personal idenfication umber (kund_lopnr_personnr), electoral district (ko_valkretskod) and year (ar)

tostring ko_valkretskod , force replace
joinby kund_lopnr_personnr ko_valkretskod  ar using "\\Mfso01\p0276_data$\valda_ko.dta", unmatched(both) _merge(_merge)
gen elected = _merge ==2  |  _merge ==3 

****add preference votes, which are in a seperate data file/
**** match by personal idenfication umber (kund_lopnr_personnr), electoral district (ko_valkretskod), ballot id (listnr) and year (ar)
drop _merge
tostring listnr, force replace
joinby kund_lopnr_personnr ko_valkretskod listnr ar using "\\Mfso01\p0276_data$\Personrost_ko_98_06.dta", unmatched(both) _merge(_merge)

****add 2010 data
append using temp

drop _merge





********destring variables
foreach var of varlist nrinom valgrund ripartikod llkk ko_valkretskod listnr partikod{
 destring `var', replace force
}




gen  parti= partinamn 
****add 1988 data
append using temp88
 
 ****calculate the number of preference votes a candidate recieves in a district
egen tag_indarkrets=tag (kund_lopnr_personnr ar ko_valkretskod )

*****
 bysort kund_lopnr_personnr  ko_valkretskod ar: egen pers_roster_b= sum(antpersonrost)
 gen pers_roster=pers_roster_b if tag_indarkrets==1



**** This calculates the number of candidates elected per ballot, 
bysort  kund_lopnr_personnr ar: egen vald_korr=max(vald)

gen vald_lista= 1 if (valgrund ==1  | valgrund ==2  | valgrund ==5  | valgrund ==6 ) &vald==1

egen tag_indar=tag (kund_lopnr_personnr ar)

gen nr_ejvald=nrinom

bysort   llkk ko_valkretskod partinamn listnr ar: egen valda=sum(elected)
bysort   llkk ko_valkretskod partinamn ar: egen valda_vkp=sum(vald_korr) if tag_indar

bysort   llkk ko_valkretskod partinamn ar: egen valda_rank=rank(valda) ,field

bysort   llkk ko_valkretskod partinamn ar: egen valda_rank1=max(valda) if valda_rank==1
bysort   llkk ko_valkretskod partinamn ar: egen valda_rank2=max(valda) if valda_rank==2

gen huvudlista_vk =1
***a list is is definded as unimportant if it has fewer than half of the elected candidates compared to the list with the most elected candidates in the district. 
replace huvudlista_vk=0 if valda_rank!=1 & ((valda_rank1>=(2*valda))|(valda==0 &valda_rank1>1))


***define list rank one of the "main" ballots***


gen rank=nrinom if huvudlista_vk==1







 
destring llkk, replace force

gen kommunkod=llkk
do "\\Mfso01\p0276_gem$\kommunkodsndringar.do"

replace llkk=kommunkod


gen nom=nrinom!=.
***keep relevant data
keep elected nrinom nom rank  alder88  ripartikod llkk parti kund_lopnr_personnr ar pers_roster 

**** collapse data so that we get on observation per individual and year
collapse (min) rank (max)nom  elected   alder88   (min) ripartikod llkk (sum) pers_roster, by ( parti kund_lopnr_personnr ar)
***drop duplicates. If there is one observation where a candidate is elected and one where it is elected always keep pbservation for which candidate is elected. 
bysort kund_lop ar: egen elec_max=max (elected)
drop if elec_max==1 & elected==0
duplicates drop ar kund, force




***calculate number of elected per party group
bysort  llkk   parti ar: egen elected_party=sum(elected) 

**** calculate total number of preference vote, and the share of those votes recieved by a candidate
bysort  llkk  parti ar: egen pers_roster_parti=sum(pers_roster)
gen pr_andel=pers_roster/pers_roster_parti

gen id=kund_lopnr_personnr 


**** add time invariant variables
joinby id using "\\Mfso01\p0276_gem$\LISA_tidsoberoende_2012.dta", unmatched(both) _merge(_merge)

drop if ar==.
****/destring variables

 foreach var of varlist Kon  FodelseAr{
 destring `var', replace force
 }
 
***define dummy  variable for gender 
 
gen woman=Kon==2 if Kon!=.

 drop _merge


fillin id  ar


gen man= woman==0

gen year=ar 
 
	

*******add register data with individual information, match on personal id and year. 

joinby id year using "\\Mfso01\p0276_gem$\LISA_allyears_2012b.dta", unmatched(master) _merge(_merge)
drop KU*  FolkFort FolkSjuk ATPFort ATPSjuk  HKapErs AldPens AldTjPTyp ForTidTyp ForTid AldTjPTyp SumTjP
drop _merge





***drop duplicates
duplicates drop ar kund, force


replace  kund_lopnr_personnr=id if  kund_lopnr_personnr==.

****define age
gen age=ar- FodelseAr
replace age=alder88 if ar==1988 

***define real wage earnings and log of real wage earnings

gen lon_real= LoneInk/0.8715 if ar==1991
replace lon_real= LoneInk/0.9532 if ar==1994
replace lon_real= LoneInk/0.98958 if ar==1998
replace lon_real= LoneInk/1.0464 if ar==2002
replace lon_real= LoneInk/1.0902 if ar==2006
replace lon_real= LoneInk/1.14944  if ar==2010

gen ln_lon_real=ln(lon_real+1)

**define years of education based on educational code (Sun200niva
***this follows the common scheme used

gen educ_year=.
replace educ_year= 7.5 if Sun2000niva>=100 & Sun2000niva<200
replace educ_year= 9.4 if Sun2000niva>=200 & Sun2000niva<300
replace educ_year= 11.2 if Sun2000niva>=300 & Sun2000niva<330
replace educ_year= 12.4 if Sun2000niva>=330 & Sun2000niva<400
replace educ_year= 14.2 if Sun2000niva>=410& Sun2000niva<530
replace educ_year= 17 if Sun2000niva>=530 & Sun2000niva<600
replace educ_year= 20.4 if Sun2000niva>=600 & Sun2000niva<=999

***define dummy for being immigrant
gen inv=SenInvAr>0 if SenInvAr!=.

****define age categories********
gen age18_29=age<30
gen age30_49=age>29& age<50
gen age50_64=age>49& age<65
gen ret_next=age>60& age<65
gen age65=age>64

****define dummy for moving to another municipality
sort id ar
gen moved=Kommun!=Kommun[_n+1] if id==id[_n+1] & Kommun!=.


*define variables for number of children, dummy for having children under 18 and dummy having more chilren in the next election period
egen num_children=rowtotal( Barn0_3- Barn16_17)
gen children=num_children>0

gen morechildren= num_children[_n+1]>num_children if kund_lopnr_personnr ==kund_lopnr_personnr[_n+1]
gen morechildren_lead= num_children[_n+2]>num_children[_n+1] if id==id[_n+2]

***create interaction term between being a women and having children
gen w_children=woman*children

****Next we want to measure the employmentsector. There are two variables that we
*** use to define this, AstSNI2002 and AstSNI92,which are two different coding schemes
*** As the changes between the two coding schemes are at the higher digit levels (i.e detailed sector)
**** we can use the variables interachangebly. The following row allows us to use 
*** the one of the two codes that we will have in a given year
egen ast= rowtotal(AstSNI2002 AstSNI92)
*** next we define the 10 occupatin sectors

gen     emp_sec=0
replace emp_sec= 1 if (ast>=1000 & ast<3000) |(ast>=5000 & ast<6000)
replace emp_sec= 2 if ast>=10000 & ast<40000 
replace emp_sec= 3 if (ast>=40000 & ast<42000 ) |(ast>=90000 & ast<91000 )
replace emp_sec= 4 if (ast>=45000 & ast<46000 )
replace emp_sec= 5 if (ast>=50000 & ast<52000 )|(ast>=60000 & ast<65000 )
replace emp_sec= 6 if (ast>=65000 & ast<73000 )|(ast>=74000 & ast<75000 )
replace emp_sec= 7 if (ast>=73000 & ast<74000 )|(ast>=80000 & ast<81000 )
replace emp_sec= 8 if (ast>=85000 & ast<86000 )
replace emp_sec= 9 if (ast>=55000 & ast<56000 )|(ast>=91000 & ast<96000 )
replace emp_sec= 10 if (ast>=75000 & ast<76000 )|(ast>=99000 & ast<100000 )

sort kund_lopnr_personnr ar

gen occ_change=ast!=ast[_n+1] if kund_lopnr_personnr ==kund_lopnr_personnr[_n+1]

gen lon_real_ch=((lon_real[_n+1]-lon_real)/lon_real)>1.25 if kund_lopnr_personnr ==kund_lopnr_personnr[_n+1]


**** add data on parliamentarians
joinby kund_lopnr_personnr ar using "\\Mfso01\MyDocs\folol\My Documents\Tidigare projekt\valda_riks.dta" , unmatched(master) _merge(_merge12)
****replace dummy for being elected to parliament with a zero if the candidate is not elected to parliament
replace vald_riks=0 if vald_riks==. 
***replace election period variable wioth year for the years that it is missing
replace valar=ar if valar==.



****define dummy for being an incumbent******
sort kund_lopnr_personnr ar
gen inc = elected[_n-1]==1 &id==id[_n-1] & llkk==llkk[_n-1] if ar>1988

****define dummy for leaving list in the next election
gen leave_lead= (nom[_n+1]!=1 |(nom[_n+1]==1  & llkk!=llkk[_n+1]) ) & kund_lopnr_personnr ==kund_lopnr_personnr[_n+1] 
sort kund_lopnr_personnr ar

****define dummy for being elected to the municipal council in the next election
gen elec_next= elected[_n+1]==1 & kund_lopnr_personnr ==kund_lopnr_personnr[_n+1] &  llkk==llkk[_n+1]

****define dummy for being elected to the parlieament in the next election
gen elec_next_riks= vald_riks[_n+1]==1 & kund_lopnr_personnr ==kund_lopnr_personnr[_n+1] &  llkk==llkk[_n+1]


***define dummy for reelection to the municipal council
gen reelection=elec_next if elected==1 & ar<2007 & ar>1987



*******************************************
****************transform elec next so that defines elected in next paeriod also as being elected to parliament*************************
replace elec_next=1 if elec_next_riks==1

***define dummy for being top ranked in the next election
sort kund_lopnr_personnr valar
gen top_next= rank[_n+1]==1 & id==id[_n+1] &  llkk==llkk[_n+1]

****gen dummy for being top ranked*****
gen top_rank=rank==1


*** generate censored rak variable so that all that are ranked below 20 are given the rank 20.
gen rank_cens=rank
replace rank_cens=20 if rank>20


***generate categorical varaible for party sice

gen size_cat = 1 if elected_party<6 
replace size_cat = 2 if elected_party<11 & elected_party>5 
replace size_cat = 3 if elected_party<16 & elected_party>10 
replace size_cat = 4 if elected_party>15 & elected_party!=. 

***** generate identifier of gender interacted with municipality
egen w_kommun=group(woman llkk)

****generate indetifier for municipality, party and election period variables
egen m_p_e=group(llkk parti ar)

***measure total seats on council
bysort llkk valar: egen seat_tot=sum(elected)


***definre categorical varaible for council size
gen council_cat= int(seat_tot/10) if seat_tot!=.
replace council_cat=6 if seat_tot>60 & seat_tot!=.





 ***dummy for remaining on party lust
 gen remain =leave_lead==0 if leave_lead!=.
 
 ****create outcomes for regressions where varaibles are scaled up by 100 to make the tables more readable. 
 foreach var in  remain leave_lead top_next elec_next{
 gen `var'_reg= `var'*100
}

 ****** generate dummy for being elected conditional of remaining on the list
 gen elec_next_rem = elec_next if remain==100 
 




****define varaible for previous number of years that a candidate has been elected. 
***start with setting it to zero
 sort id valar
gen exp= 0 
*** ad 1 for each year that they have been elected previously
**** we go five election periods back. As we have a balanced panel due to the fillin
*** we will go back to the same number of election years for every individual

forvalues n=1/4{

	replace exp=exp+1 if  elected[_n-`n']==1 &id==id[_n-`n'] & llkk==llkk[_n-`n'] 
}
 
 **** create variable kommunkod wihich is another name used for municipal id, which we need to add other data.
gen kommunkod=llkk

*****add election data, merge based on municipal id (kommundkod) and election period (valar)
joinby valar kommunkod using "\\Mfso01\p0276_gem$\valdata_gender.dta", unmatched(both) _merge(_mergex)



 ****rename competition variables
ren h_v_diff_3lat comp_blockdiff
ren  mar_maj_rost_proc comp_maj_mar

***interact competition variables with female dummy
gen w_comp_blockdiff=comp_blockdiff*woman
gen w_comp_maj_mar=woman*comp_maj_mar
 ***give competion variables negative sign to that the estiamtes can be interpreted as that from an increase in competition.
 foreach var of varlist comp_maj_mar w_comp_maj_mar  w_comp_blockdiff comp_blockdiff{
 
 replace `var' = 0-`var' 
 }

****correct party name variable**************

replace parti = "Kristdemokraterna" if parti=="Kristdemokratiska Samhllspartiet (Kds)"
replace parti= "Vnsterpartiet" if parti=="VNSTERPARTIET"
replace parti= "Miljpartiet de grna" if parti=="MILJPARTIET DE GRNA"
replace parti= "Centerpartiet" if parti=="Centern"
replace parti= "Annat" if ripartikod>100 & ar>1990



**generate dummies for each election year
foreach year in 1991 1994 1998 2002 2006 2010{
	gen dum_`year'=ar==`year'
}

***generate dummies foreach party, we do this based on party name.
  gen dum_s= parti=="Arbetarepartiet-Socialdemokraterna" 
  gen dum_c= parti=="Centerpartiet"
  gen dum_fp= parti=="Folkpartiet liberalerna"
  gen dum_kd= parti=="Kristdemokraterna"
  gen dum_mp= parti=="Miljpartiet de grna"
  gen dum_m= parti=="Moderata Samlingspartiet"
  gen dum_v= parti=="Vnsterpartiet"
  gen dum_a= parti=="Annat"
  

****define dummy for years that a party intorduced a gender quota
gen quota_year= (dum_s==1 & valar==1991)| (dum_v==1 & valar==1991) |(dum_v==1 & valar==1994)|(dum_mp==1 & valar==1994)
 keep if elected==1
  


***generate dummy for being a left wing party***

gen left_dum=1 if dum_s+dum_v+dum_mp==1

replace left_dum=0 if dum_m+dum_c+dum_fp+dum_kd==1

**** generate dummy for being one of the 7 parties historically represented i the national parliament
gen nat_dum=1 if dum_s+dum_v+dum_mp+ dum_m+dum_c+dum_fp+dum_kd==1

****generate interaction between female dummy and left wing party
gen w_left_dum=left_dum*woman


***** add data for income residual, which my use to measure competence, this is added based on personal id.

joinby id using "\\Mfso01\MyDocs\folol\My Documents\Tidigare projekt\avg_income.dta", unmatched(master) 
*********ad data with municipal control variables, mathc by year (ar) and municipal id (kommundkod)
drop _merge
  joinby ar kommunkod using "\\Mfso01\MyDocs\folol\My Documents\Tidigare projekt\kommungruppindelning.dta" , unmatched(master) _merge(_merge)
drop _merge
*********ad data with municipal municipal wage gap, match by year (ar) and municipal id (kommundkod)
joinby kommunkod ar using "\\Mfso01\MyDocs\folol\My Documents\Tidigare projekt\gender wage gap 1991_2011.dta", unmatched(master) _merge(_merge)
drop _merge
sort kund_lopnr_personnr valar 
***dropp any duplicates that could have appeared thorugh the added files
duplicates drop ar kund, force

****add data on appointments, which is used for descriptive analysis
joinby kund_lopnr_personnr valar using "\\Mfso01\MyDocs\folol\My Documents\Tidigare projekt\ord_vice_comb.dta", unmatched(both) _merge(_merge4)


*** rename dummy for chair

ren ord chair

****rename wage variable
ren lon_real real_wage


***** generate preference vote variable, scale upp with 100 to make outcome easier to interpret
gen prefvote_reg= pr_andel*100
***rename election period variable

 ren valar electionperiod
save temp_femrep, replace

